<!--
SPDX-FileCopyrightText: 2024 Auxolotl Infrastructure Contributors
SPDX-FileCopyrightText: 2024 Clicks Codes

SPDX-License-Identifier: GPL-3.0-only
-->

# Clicks - Infrastructure

This repository contains system configuration for Clicks's infrastructure.

## Config

Config is written using Snowfall lib. It keeps us organized and has some nice features like namespaces.

## Systems

`a` stands for "area", `d` stands for "device". So for example, `a1d1` is device 1 in area 1. Areas are generally
managed by one member of Clicks, who has full access to all of the servers in that area. If you require help for a
specific area you can email `admin@clicks.codes` and in the subject line include the area you want help for.

| System                                              | Description                                                   | Address                 |
| --------------------------------------------------- | ------------------------------------------------------------- | ----------------------- |
| [a1d1](./systems/x86_64-linux/a1d1/default.nix)     | Primary Host                                                  | `d1.a1.clicks.domains`  |
| [a1d2](./systems/x86_64-linux/a1d2/default.nix)     | Build Server                                                  | `d2.a1.clicks.domains`  |

## Deploying

Deploys are done with deploy-rs, you'll need to be able to ssh into a machine with its hostname (either by a nifty `.ssh/config` rule or `tailscale`).

Once you've done that, you'll be able to deploy with
```bash
$ deploy .#MACHINE_NAME
```
